/*
 *	Tykkipeli 2
 *	Shop screen.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include "defines.h"
#include "tp2.h"
#include "game_screen.h"
#include "artificial_stupidity.h"
#include "info_windows.h"
#include "players.h"
#include "weapons.h"
#include "shields.h"
#include "shield_defines.h"

#include "hr_colors.h"
#include "hr_zones.h"
#include "hr_mouse.h"
#include "hr_bobs.h"
#include "hr_fonts.h"
#include "hr_bitmaps.h"
#include "hr_buttons.h"
#include "hr_defines.h"
#include "hr_general.h"
#include "hr_input_handler.h"
#include "hr_keyboard.h"
#include "hr_screens.h"
#include "hr_graphics.h"
#include "hr_strings.h"

/*How many lines are scrolled at once in shop */
#define SHOP_JUMPSCROLL 5
#define SHOP_ITEMS_ON_SCREEN 44

struct hr_zone *old_zone2=NULL,*zone_up=NULL,*zone_down=NULL;

/* Draws a border around a shop list item, and watches whether
 * mouse pointer is on one of the scroll zones.*/
int shop_handler()
{
	struct hr_zone *zp;
	/* Get current zone.*/
	zp=hr_get_zone(hr.firstzone,hr_mouse.x,hr_mouse.y,ZONE_ENABLED);
	/* Return 1 if mouse has been moved from one zone to another. */
	if(zp!=old_zone2)
	  return 1;
	/* Tell hr_input_handler() to exit if pointer is on scroll zone.*/
	if(zp!=NULL){
		if((zp==zone_up)||
			(zp==zone_down))
		  return 1;
	}
	return 0;
}


/* Shop... */
void shop()
{
	struct hr_button *b,*b1,*b2,*b3,*sb;
	struct hr_zone *zp,*ozp,*shop_zone[SHOP_ITEMS_ON_SCREEN];
	struct player *p;
	struct weapon **w_array,*wp,*tw;
	struct shield **s_array,*sp,*ts;
	struct weapon_list *wl=NULL;
	struct shield_list *sl=NULL;
	unsigned char tmp[BUFFER_SIZE];
	int m,ok,l,yl,oyl,c,bflags,mode_change=1,visible,zonenumber;
	void *ptr;
	

	/* Delete all existing zones and buttons.*/
	while(hr_delete_button(hr.firstbutton));
	while(hr_delete_zone(hr.firstzone));
	
	/* To make things easier, two pointer arrays are created.
	 * Pointers to weapons/shields are stored in those arrays.
	 * For example, 5th weapon will be pointed to by 5th pointer
	 * in the array.*/
	/* Even tho space is reserved for the (None) shield,
	 * it is never shown (yl is never decremented below 1).*/
	w_array=malloc(sizeof(struct weapon *)*weapon_n);
	s_array=malloc(sizeof(struct shield *)*shield_n);
	/* Set pointers to weapons */
	l=0;
	wp=firstweapon;
	while(wp!=NULL) {
		*(w_array+l++)=wp;
		wp=wp->next;
	}
	/* Set pointers to shields */
	l=0;
	sp=firstshield;
	while(sp!=NULL) {
		*(s_array+l++)=sp;
		sp=sp->next;
	}	
	
	hr_screen_open(G640x480x256,NONE);	
	set_game_palette();
	set_player_colors();
	
	hr_bevelbox(0,0,639,479,hr.def_colors,NONE);
	hr.default_button=b1=hr_create_button(581,2,637,18,
													 hr.font8x8,hr.def_colors,
													 "E~ux~uit","Bye",'x',BUTTON_ENABLED);
	b2=hr_create_button(461,2,579,18,
							  hr.font8x8,hr.def_colors,
							  "~uI~unformation","~uI~unfo mode",'i',
							  BUTTON_ENABLED|BUTTON_SWITCH);
	b3=hr_create_button(361,2,459,18,
							  hr.font8x8,hr.def_colors,
							  "~uS~uwap","->~uS~uwap<-",'s',BUTTON_ENABLED);
	/* Slider */
	sb=hr_create_button(448,33,459,477,
							  hr.font8x8,hr.def_colors,
							  NULL,NULL,0,
							  BUTTON_VSLIDER|BUTTON_PRESSED|BUTTON_ENABLED);
	
	hr_textbox(461,20,519,31,
				  hr.font8x8,
				  hr.def_colors,
				  "Cost",STRING_START,STRING_END,
				  BUTTON_PRESSED|BUTTON_ENABLED);
	hr_textbox(521,20,579,31,
				  hr.font8x8,
				  hr.def_colors,
				  "Bought",STRING_START,STRING_END,
				  BUTTON_PRESSED|BUTTON_ENABLED);
	hr_bevelbox(2,33,446,477,hr.def_colors,BUTTON_PRESSED);
	hr_bevelbox(461,33,519,477,hr.def_colors,BUTTON_PRESSED);
	hr_bevelbox(521,33,579,477,hr.def_colors,BUTTON_PRESSED);
#if 1
	gl_fillbox(581,20,59,460,2);
#endif
	
	zone_up=hr_create_zone(0,0,447,1,ZONE_ENABLED);
	zone_down=hr_create_zone(0,478,447,479,ZONE_ENABLED);

	for(l=0;l<SHOP_ITEMS_ON_SCREEN;l++)
	  shop_zone[l]=hr_create_zone(4,34+l*10,444,44+l*10,ZONE_ENABLED);

	/* Go through all players*/
	p=firstplayer;
	while((p!=NULL) && !(game_flags & GAME_ABORTED)) {
		hr_set_color_index(temp_colors,COLOR_FOREGROUND,p->britecolor);
		hr_textbox(2,2,289,18,
					  hr.font8x8,
					  temp_colors,
					  p->name,STRING_START,STRING_END,
					  BUTTON_PRESSED|BUTTON_ENABLED);
		sprintf(tmp,"%d",p->wealth);
		hr_textbox(291,2,359,18,
					  hr.font8x8,
					  temp_colors,
					  tmp,STRING_START,STRING_END,
					  BUTTON_PRESSED|BUTTON_ENABLED);
		m=ok=0;oyl=-666;yl=m;
		ozp=zp=NULL;
		
		game_flags &= ~(INFO_MODE);		/* Toggle off info mode */
		bflags=(((game_flags & INFO_MODE)?(BUTTON_PRESSED):(NONE))|BUTTON_ENABLED|
				  BUTTON_SWITCH);
		hr_update_button(b2,UPDATE_FLAGS,&bflags);

		hr_clearkey();
		
		/* Loop until "Exit" is clicked. */
		if(p->flags & DROID)
		  auto_shop(p);
		else
		  while(!ok) {
			  /* Redraw list if necessary */			
			  if(oyl!=yl) {
				  if(mode_change){
					  mode_change=0;
					  /* Slider */
					  free(sb->extras);
					  l=((m==0)?(weapon_n):(shield_n))-(43+m);
					  visible=10;				/* FIX! Calc correct value. */
					  sb->extras=hr_create_slider(BUTTON_VSLIDER|SLIDER_GET_YVALINT|
															SLIDER_SET_YVALINT,
															0,0,0,0,NULL,
															l,visible,yl,m,&yl);
					  /**/
					  hr_textbox(2,20,459,31,
									 hr.font8x8,
									 hr.def_colors,
									 ((m==0)?("Weapon name"):("Shield name")),
									 STRING_START,STRING_END,
									 BUTTON_PRESSED|BUTTON_ENABLED);
				  }
				  hr_update_button(sb,UPDATE_GFXONLY,NULL);
				  gl_fillbox(3,34,443,443,0);
				  gl_fillbox(462,34,56,443,0);
				  gl_fillbox(522,34,56,443,0);				
				  for(l=0;l<SHOP_ITEMS_ON_SCREEN;l++) {
					  if((yl+l)>=((m==0)?(weapon_n):(shield_n)))
						 break;
					  c=1;
					  /* Get amount of this item owned by player p */
					  strcpy(tmp,"-");
					  if(m==0) {
						  wl=p->weapons;
						  while((wl->type)!=(*(w_array+yl+l)))
							 wl=wl->next;
						  if((wl->amount)>0)
						  	 sprintf(tmp,"%d",wl->amount);
						  else if((wl->amount)<0)
						  	 strcpy(tmp,"Inf.");
						  /* Set color to black if the weapon is too expensive
							* to be bought */
						  if(((wl->type->cost)>(p->wealth)) ||
							  ((wl->amount)==-1))
							 c=2;
					  }
					  else{
						  sl=p->shields;
						  while((sl->type)!=(*(s_array+yl+l)))
							 sl=sl->next;
						  if((sl->type->index)!=CHARS2INT("None")){
							  if((sl->amount)>0)
								 sprintf(tmp,"%d%%",(((sl->amount)*100)/
															sl->type->efficiency));
							  /* Set color to black if shield is too xpensive...*/
							  if((sl->type->cost)>(p->wealth))
								 c=2;
						  }
						  else
							 c=2;
					  }
					  /* print Amount...*/
					  HR_CENTER(550,36+l*10,c,0,tmp,hr.font8x8,NONE);
					  /* Name... */
					  sprintf(tmp,"%s",
								 (m==0)?(wl->type->name):(sl->type->name));
					  tmp[54]=0;				/* Truncate too long lines */
					  hr_write(5,36+l*10,c,0,tmp,
								  hr.font8x8,STRING_START,STRING_END,NONE);
					  /* Cost ... */
					  sprintf(tmp,"%d",(m==0)?(wl->type->cost):(sl->type->cost));
					  hr_write(512-strlen(tmp)*8,36+l*10,
								  c,0,tmp,
								  hr.font8x8,STRING_START,STRING_END,NONE);
				  }
				  oyl=yl;
				  old_zone2=ozp=NULL;
			  }
			  else
				 old_zone2=zp;
			  /* Get active button and active zone.*/
			  b=hr_input_handler(NULL,&shop_handler,KBD_PRESSED|AMB_PRESSED);
			  /* Zone.*/
			  zp=hr_get_zone(hr.firstzone,hr_mouse.x,hr_mouse.y,ZONE_ENABLED);
			  /* Item Box.*/
			  if(ozp!=zp){
				  /* Remove old border */
				  if(ozp!=NULL){
#ifndef XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
					  for(l=0;l<SHOP_ITEMS_ON_SCREEN;l++){
						  if(shop_zone[l]==ozp){
							  if((yl+l)<((m==0)?(weapon_n):(shield_n))){
								  hr_box(ozp->x1,ozp->y1,ozp->x2,ozp->y2,
											hr_get_color_index(hr.def_colors,
																	 COLOR_BACKGROUND),
											NONE);
								  break;
							  }
						  }
					  }
				  }
				  /* Draw new border */
				  if(zp!=NULL){
					  for(l=0;l<SHOP_ITEMS_ON_SCREEN;l++){
						  if(shop_zone[l]==zp){
							  if((yl+l)<((m==0)?(weapon_n):(shield_n))){
								  hr_bevelbox(zp->x1,zp->y1,zp->x2,zp->y2,
												  hr.def_colors,BUTTON_PRESSED);
								  break;
							  }
						  }
					  }
				  }
#endif
				  ozp=zp;
			  }
			  /* Buttons */
			  if(b!=NULL) {
				  if(hr_input_handler(b,NULL,LMB_RELEASED) == b) {
					  if(b==b1)
						 ok=1;
					  else if(b==b2)
						 game_flags ^= INFO_MODE;
					  else if(b==b3){
						  m=((m==0)?(1):(0));
						  mode_change=1;
						  yl=m;oyl=-666;
					  }
				  }
			  }
			  /* Scrolling */
			  if(zp==zone_up){
				  /* Scroll back */
				  yl-=SHOP_JUMPSCROLL;
				  if(yl<m)
					 yl=m;
			  }
			  else if(zp==zone_down){
				  /* Scroll forth */
				  yl+=SHOP_JUMPSCROLL;
				  if((yl+43)>((m==0)?(weapon_n):(shield_n)) )
					 yl=((m==0)?(weapon_n):(shield_n))-44;
				  if(yl<m)
					 yl=m;
				  break;
			  }			  
			  /* Keypresses */
			  switch(hr_keyboard.lastkey){
				case 27:
				  /* Abort? */
				  if(hr_ask_confirmation("Abort game?")){
					  game_flags |= GAME_ABORTED;
					  ok=1;
				  }
				  break;
			  }
			  /* Buying/returning items */
			  if(zp!=NULL){
				  zonenumber=0;
				  for(l=0;l<SHOP_ITEMS_ON_SCREEN;l++){
					  if(shop_zone[l]==zp){
						  zonenumber=l+1;
						  break;
					  }
				  }
				  if(((HR_LMB)||(HR_RMB)) && (zonenumber>0)) {
					  l=yl+zonenumber-1;
					  if(l<((m==0)?(weapon_n):(shield_n)) )  {
						  if(game_flags & INFO_MODE){
							  if(m==0){
								  tw=firstweapon;
								  for(c=0;c<l;c++)
									 tw=tw->next;
								  ptr=(void *)tw;
							  }
							  else{
								  ts=firstshield;
								  for(c=0;c<l;c++)
									 ts=ts->next;
								  ptr=(void *)ts;
							  }
							  item_information(m,ptr,50,50,WIDTH-50,HEIGHT-50);
						  }
						  else {
							  if(m==0){
								  /* Seek correct weapon_list node */
								  wl=p->weapons;
								  while((wl->type)!=(*(w_array+l)))
									 wl=wl->next;
								  /* Buy/Restore Weapon */
								  if(HR_LMB) {
									  /* Buy Weapon */
									  if(((wl->type->cost)<=(p->wealth)) &&
										  ((wl->amount)>=0)) {
										  ++(wl->amount);
										  p->wealth-=(wl->type->cost);
									  }
								  }
								  else {
									  /* Restore weapon*/
									  if((wl->amount)>0) {
										  --(wl->amount);
										  p->wealth+=(wl->type->cost);
									  }
								  }
							  }
							  else{
								  /* Seek correct shield_list node */
								  sl=p->shields;
								  while((sl->type)!=(*(s_array+l)))
									 sl=sl->next;
								  /* Buy/Restore Shield */
								  if(HR_LMB){
									  /* Buy shield to max. */
									  if(((sl->type->cost)<=(p->wealth)) &&
										  (sl->amount)<(sl->type->efficiency)){
										  sl->amount=(sl->type->efficiency);
										  p->wealth-=(sl->type->cost);
									  }
								  }
								  else {
									  /* Sell shield */
									  if((sl->amount)>0) {
										  p->wealth+=
											 ((sl->amount)*(sl->type->cost))/
											 (sl->type->efficiency);
										  sl->amount=0;
									  }
								  }
							  }
							  sprintf(tmp,"%d",p->wealth);
							  hr_textbox(291,2,359,18,
											 hr.font8x8,
											 temp_colors,
											 tmp,STRING_START,STRING_END,
											 BUTTON_PRESSED|BUTTON_ENABLED);
							  oyl=-666;			/* Make sure list is redrawn */
						  }
					  }
					  hr_input_handler(NULL,NULL,AMB_RELEASED);
				  }
			  }
			  
		  }
		p=p->next;
	}
	free(w_array);
	free(s_array);
	while(hr_delete_button(hr.firstbutton));
	while(hr_delete_zone(hr.firstzone));
	hr_screen_close(hr.active_screen);
}
